/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables.records;


import de.ship.db.enums.EnumAccesslevel;
import de.ship.db.tables.TCoreUserprivilege;

import java.time.LocalDateTime;

import org.jooq.Record1;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreUserprivilegeRecord extends UpdatableRecordImpl<TCoreUserprivilegeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>common_dd.t_core_userprivilege.lastchange</code>.
     */
    public void setLastchange(LocalDateTime value) {
        set(0, value);
    }

    /**
     * Getter for <code>common_dd.t_core_userprivilege.lastchange</code>.
     */
    public LocalDateTime getLastchange() {
        return (LocalDateTime) get(0);
    }

    /**
     * Setter for <code>common_dd.t_core_userprivilege.pk</code>.
     */
    public void setPk(Integer value) {
        set(1, value);
    }

    /**
     * Getter for <code>common_dd.t_core_userprivilege.pk</code>.
     */
    public Integer getPk() {
        return (Integer) get(1);
    }

    /**
     * Setter for <code>common_dd.t_core_userprivilege.fk_privilege</code>.
     */
    public void setFkPrivilege(Integer value) {
        set(2, value);
    }

    /**
     * Getter for <code>common_dd.t_core_userprivilege.fk_privilege</code>.
     */
    public Integer getFkPrivilege() {
        return (Integer) get(2);
    }

    /**
     * Setter for <code>common_dd.t_core_userprivilege.fk_usnr</code>.
     */
    public void setFkUsnr(Integer value) {
        set(3, value);
    }

    /**
     * Getter for <code>common_dd.t_core_userprivilege.fk_usnr</code>.
     */
    public Integer getFkUsnr() {
        return (Integer) get(3);
    }

    /**
     * Setter for <code>common_dd.t_core_userprivilege.shippie_acl</code>.
     */
    public void setShippieAcl(EnumAccesslevel value) {
        set(4, value);
    }

    /**
     * Getter for <code>common_dd.t_core_userprivilege.shippie_acl</code>.
     */
    public EnumAccesslevel getShippieAcl() {
        return (EnumAccesslevel) get(4);
    }

    /**
     * Setter for <code>common_dd.t_core_userprivilege.shipdesigner_acl</code>.
     */
    public void setShipdesignerAcl(EnumAccesslevel value) {
        set(5, value);
    }

    /**
     * Getter for <code>common_dd.t_core_userprivilege.shipdesigner_acl</code>.
     */
    public EnumAccesslevel getShipdesignerAcl() {
        return (EnumAccesslevel) get(5);
    }

    /**
     * Setter for <code>common_dd.t_core_userprivilege.square_acl</code>.
     */
    public void setSquareAcl(EnumAccesslevel value) {
        set(6, value);
    }

    /**
     * Getter for <code>common_dd.t_core_userprivilege.square_acl</code>.
     */
    public EnumAccesslevel getSquareAcl() {
        return (EnumAccesslevel) get(6);
    }

    /**
     * Setter for <code>common_dd.t_core_userprivilege.sam_acl</code>.
     */
    public void setSamAcl(EnumAccesslevel value) {
        set(7, value);
    }

    /**
     * Getter for <code>common_dd.t_core_userprivilege.sam_acl</code>.
     */
    public EnumAccesslevel getSamAcl() {
        return (EnumAccesslevel) get(7);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached TCoreUserprivilegeRecord
     */
    public TCoreUserprivilegeRecord() {
        super(TCoreUserprivilege.T_CORE_USERPRIVILEGE);
    }

    /**
     * Create a detached, initialised TCoreUserprivilegeRecord
     */
    public TCoreUserprivilegeRecord(LocalDateTime lastchange, Integer pk, Integer fkPrivilege, Integer fkUsnr, EnumAccesslevel shippieAcl, EnumAccesslevel shipdesignerAcl, EnumAccesslevel squareAcl, EnumAccesslevel samAcl) {
        super(TCoreUserprivilege.T_CORE_USERPRIVILEGE);

        setLastchange(lastchange);
        setPk(pk);
        setFkPrivilege(fkPrivilege);
        setFkUsnr(fkUsnr);
        setShippieAcl(shippieAcl);
        setShipdesignerAcl(shipdesignerAcl);
        setSquareAcl(squareAcl);
        setSamAcl(samAcl);
        resetChangedOnNotNull();
    }
}
